import { IgrDataContext } from "igniteui-react-core";
import { FunnelSliceDataContext as FunnelSliceDataContext_internal } from "./FunnelSliceDataContext";
import { brushToString, stringToBrush } from "igniteui-react-core";
/**
 * Represents the funnel slice data currently in context.
*/
export class IgrFunnelSliceDataContext extends IgrDataContext {
    createImplementation() {
        return new FunnelSliceDataContext_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Gets or sets the Outline to use to color the item.
    */
    get itemOutline() {
        return brushToString(this.i.itemOutline);
    }
    set itemOutline(v) {
        this.i.itemOutline = stringToBrush(v);
    }
}
