import { IgrSplineSeriesBase } from "./igr-spline-series-base";
import { toPoint, fromPoint } from "igniteui-react-core";
/**
 * Represents one part in a StackedSplineSeries or StackedSplineAreaSeries.
*/
export class IgrSplineFragmentBase extends IgrSplineSeriesBase {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series is a stack fragment.
    */
    get isFragment() {
        return this.i.dx;
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.ps(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
}
