import { FunnelSliceClickedEventArgs as FunnelSliceClickedEventArgs_internal } from "./FunnelSliceClickedEventArgs";
import { fromRect, toRect } from "igniteui-react-core";
/**
 * Information about the clicked slice.
*/
var IgrFunnelSliceClickedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrFunnelSliceClickedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrFunnelSliceClickedEventArgs.prototype.createImplementation = function () {
        return new FunnelSliceClickedEventArgs_internal();
    };
    Object.defineProperty(IgrFunnelSliceClickedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrFunnelSliceClickedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrFunnelSliceClickedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrFunnelSliceClickedEventArgs.prototype, "index", {
        /**
         * The index of the clicked slice.
        */
        get: function () {
            return this.i.index;
        },
        set: function (v) {
            this.i.index = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrFunnelSliceClickedEventArgs.prototype, "bounds", {
        /**
         * The bounds of the slice.
        */
        get: function () {
            return fromRect(this.i.bounds);
        },
        set: function (v) {
            this.i.bounds = toRect(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrFunnelSliceClickedEventArgs.prototype, "item", {
        /**
         * The data item for the clicked slice.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrFunnelSliceClickedEventArgs;
}());
export { IgrFunnelSliceClickedEventArgs };
