import { __extends } from "tslib";
import { IgrSplineSeriesBase } from "./igr-spline-series-base";
import { SplineAreaSeries } from "./SplineAreaSeries";
/**
 * Represents a IgxDataChartComponent spline area series.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrNumericXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrSplineAreaSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value"
* />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrSplineAreaSeries({name:"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "Value";
* ```
*/
var IgrSplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSplineAreaSeries, _super);
    function IgrSplineAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrSplineAreaSeries.prototype.createImplementation = function () {
        return new SplineAreaSeries();
    };
    Object.defineProperty(IgrSplineAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSplineAreaSeries.prototype, "isArea", {
        /**
         * Gets whether the current series shows an area shape.
        */
        get: function () {
            return this.i.df;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSplineAreaSeries.prototype, "isSpline", {
        /**
         * Gets whether the current series shows a spline shape.
        */
        get: function () {
            return this.i.ej;
        },
        enumerable: false,
        configurable: true
    });
    return IgrSplineAreaSeries;
}(IgrSplineSeriesBase));
export { IgrSplineAreaSeries };
