import { __extends } from "tslib";
import { IgrBrushScale } from "./igr-brush-scale";
import { ValueBrushScale } from "./ValueBrushScale";
import { ensureBool } from "igniteui-react-core";
/**
 * Represents a brush scale that uses value-based brush selection.
*/
var IgrValueBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrValueBrushScale, _super);
    function IgrValueBrushScale(props) {
        return _super.call(this, props) || this;
    }
    IgrValueBrushScale.prototype.createImplementation = function () {
        return new ValueBrushScale();
    };
    Object.defineProperty(IgrValueBrushScale.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value for this scale.
        */
        get: function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value for this scale.
        */
        get: function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "isLogarithmic", {
        /**
         * Gets or sets whether the scale is logarithmic.
        */
        get: function () {
            return this.i.isLogarithmic;
        },
        set: function (v) {
            this.i.isLogarithmic = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "logarithmBase", {
        /**
         * Gets or sets the logarithm base for this scale.
        */
        get: function () {
            return this.i.logarithmBase;
        },
        set: function (v) {
            this.i.logarithmBase = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "isReady", {
        /**
         * Checks if the value brush scale is ready for usage in the chart
        */
        get: function () {
            return this.i.isReady;
        },
        enumerable: false,
        configurable: true
    });
    return IgrValueBrushScale;
}(IgrBrushScale));
export { IgrValueBrushScale };
