import { Type } from "igniteui-react-core";
/**
 * Describes available locations of the axis labels in the chart.
 */
export declare enum AutoMarginsAndAngleUpdateMode {
    /**
     * Auto margins and auto angle are for initial view only.
     */
    None = 0,
    /**
     * Auto margins and auto angle are re-evaluated as the size of the component is altered.
     */
    SizeChanging = 1,
    /**
     * Auto margins and auto angle are re-evalueated as the size of the component changes, auto angles are re-evaluated when zoom changes, possibly leading to a margin update.
     */
    SizeChangingAndZoom = 2
}
/**
 * @hidden
 */
export declare let AutoMarginsAndAngleUpdateMode_$type: Type;
