import { Type } from "igniteui-react-core";
/**
 * Enum used to determine positioning logic for data items which have been consolidated into a single visual element.
 */
export declare enum ConsolidatedItemsPosition {
    /**
     * Consolidated Items should be positioned using their minimum value.
     */
    Minimum = 0,
    /**
     * Consolidated Items should be positioned using their maximum value.
     */
    Maximum = 1,
    /**
     * Consolidated Items should be positioned at the midpoint of the range.
     */
    Median = 2,
    /**
     * Consolidated Items should be positioned using the value nearest to the reference value of the corresponding axis.
     */
    RelativeMinimum = 3,
    /**
     * Consolidated Items should be positioned using the value farthest from the reference value of the corresponding axis.
     */
    RelativeMaximum = 4
}
/**
 * @hidden
 */
export declare let ConsolidatedItemsPosition_$type: Type;
