import { Type } from "igniteui-react-core";
/**
 * Describes the highlighting mode to use for the series in the chart.
 */
export declare enum LegendHighlightingMode {
    /**
     * Highlighting mode is determined by the component.
     */
    Auto = 0,
    /**
     * Legend will not attempt to highlight series when rolling over legend items.
     */
    None = 1,
    /**
     * On rollover of legend, series will highlight matching the highlight configuration of the series.
     */
    MatchSeries = 2
}
/**
 * @hidden
 */
export declare let LegendHighlightingMode_$type: Type;
