import { ILegendSeries } from "igniteui-react-core";
import { ILegendOwner } from "igniteui-react-core";
import { LegendMouseEventArgs as LegendMouseEventArgs_internal } from "./LegendMouseEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Provides data for legend mouse button related events.
*/
export declare class IgrLegendMouseEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): LegendMouseEventArgs_internal;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets a reference to the object that raised the event.
    */
    get originalSource(): any;
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    get item(): any;
    set item(v: any);
    /**
     * Gets the series associated with the current event.
    */
    get series(): ILegendSeries;
    set series(v: ILegendSeries);
    /**
     * Gets the Chart associated with the current event.
    */
    get chart(): ILegendOwner;
    set chart(v: ILegendOwner);
    /**
     * The legend item in context.
    */
    get legendItem(): any;
    set legendItem(v: any);
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    toString(): string;
}
